#include <Application.h>
#include <Messenger.h>
#include <StopWatch.h>

#include <iostream>
using namespace std;

#define APP_SIG "application/x-vnd.nhs.eavesdropper.client"
#define MSG_GO 'evc0'


class App : public BApplication
{
public:
						App();
						~App() {}
	void				MessageReceived(BMessage* msg);
};

int main() 
{
	App app;
	app.Run();
	
	return 0;
};

App::App()
 : BApplication(APP_SIG) 
{
	PostMessage(MSG_GO);
}
 

void
App::MessageReceived(BMessage* msg)
{
	switch(msg->what) 
	{
		case MSG_GO: 
		{
			BMessenger server("application/x-vnd.NHS.eavesdropper.server");
			if( server.IsValid() )
			{
				BMessage req(B_GET_PROPERTY), resp(B_NO_REPLY);
				req.AddSpecifier("data-XML");
				server.SendMessage(&req, &resp, 1000000, 4000000);
//				BStopWatch *stopWatch = new BStopWatch("Exec time") ;
				if( resp.what == B_REPLY )
				{
					const char* data;
					if( resp.FindString("result", &data) == B_OK )
						cout<<data<<endl;
//					delete stopWatch;
				}
			}
			PostMessage(B_QUIT_REQUESTED);
		}
			break;
		
		default:
			BApplication::MessageReceived(msg);
	}
}
