#include "SoundPlayMod.h"

#include <Clipboard.h>
#include <OS.h>

//include log_item defs from Playlog;
//if this were a really professional plugin-style architecture
//this would only be visible in the build of the SoundPlayModule plugin.
//...but...it's not.
#include "LogItem.h"

SoundPlayMod::SoundPlayMod()
	: Module("SoundPlayModule")
{
}

SoundPlayMod::~SoundPlayMod()
{}

status_t
SoundPlayMod::Execute(App* app)
{
	if( fData.CountChars() > 0 )
		fData.Remove( 0, fData.CountChars() );

	BClipboard* clipboard = new BClipboard("eavesdropper");
	BMessenger PLHandler;
	if( clipboard->Lock() )
	{
		BMessage* clipMsg = clipboard->Data();
		if( clipMsg == NULL )
			return B_ERROR;
		if( clipMsg->FindMessenger( "messenger", &PLHandler ) != B_OK )
			return B_ERROR;
		clipboard->Unlock();
	}
	delete clipboard;
	
	if( !PLHandler.IsValid() )
		return B_ERROR;
		
	fData<<"<"<<Name()<<">";
	
	BMessage dataReq(B_GET_PROPERTY), dataResp;
	dataReq.AddSpecifier("logitem");
	PLHandler.SendMessage( &dataReq, &dataResp );
	
	//dataResp now contains the data returned by PlayLog;
	//take this and turn it into XML
	int32 archiveCt;
	type_code type;
	if( dataResp.GetInfo("result", &type, &archiveCt) == B_OK )
	{
		for(int32 ctr=0; ctr<archiveCt; ctr++)
		{
			BMessage archive;
			if( dataResp.FindMessage("result", ctr, &archive) == B_OK )
			{
				log_item* logitem = (log_item*)instantiate_object(&archive);
				fData<<logitem->XMLize().String();
				delete logitem;
			}
		}
	}
					
	fData<<"</"<<Name()<<">";
	fLastExecution = real_time_clock();
	return fExecStatus = B_OK;
}
