#ifndef LogItem_h
#define LogItem_h

#include <Archivable.h>
#include <String.h>

class log_item : public BArchivable
{
public:
								log_item( BString title, time_t date )
									: fTitle(title), fDate(date) {}
		
								log_item( BMessage* msg);
	static BArchivable*			Instantiate( BMessage* msg);
	virtual status_t			Archive( BMessage* msg, bool deep = true ) const ;
	virtual BString				XMLize( ) const;
	
	BString	fTitle; // using BString to avoid linking libstdc++.r4.so
	time_t	fDate;	
};

struct attrib_log_item : public log_item
{
public:
	attrib_log_item(BString artist, BString album, BString title, BString track, time_t date)
		: log_item(title, date), fArtist(artist), fAlbum(album), fTrack(track)
	{}

								attrib_log_item( BMessage* msg);
	static BArchivable*			Instantiate( BMessage* msg);
	status_t					Archive( BMessage* msg, bool deep = true ) const;
	BString						XMLize() const;

	BString	fArtist, fAlbum, fTrack;

};

#endif
